/***************************************************************************
                          bgematria.cpp  -  description
                             -------------------
    begin                : Tue Nov 30 1999
    copyright            : (C) 1999 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <qmessagebox.h>
#include <qdir.h>
#include <qfile.h>

#include "bgematria.h"

BGematria::BGematria()
{
 for(int k=0;k<8;k++) gemsum[k]=0;
}

BGematria::~BGematria()
{
}

void BGematria::berGematria(QString text)
{
// Gematria Tabelle
 int tabgem[6][27]={
/*0=absolute*/      {1,2,3,4,5,6,7,8,9,
                     10,20,20,30,40,40,50,50,60,70,80,80,90,90,
                     100,200,300,400},
/*1=absolutrevers*/ {400,300,200,100,90,80,70,60,50,
                     40,30,30,20,10,10,9,9,8,7,6,6,5,5,
                     4,3,2,1},
/*2=reducts*/       {1,2,3,4,5,6,7,8,9,
                     1,2,2,3,4,4,5,5,6,7,8,8,9,9,
                     1,2,3,4},
/*3=ordinal*/       {1,2,3,4,5,6,7,8,9,
                     10,11,11,12,13,13,14,14,15,16,17,17,18,18,
                     19,20,21,22},
/*4=quadrat*/       {1,4,9,16,25,36,49,64,81,
                     100,121,121,144,169,169,196,196,225,256,289,289,324,324,
                     361,400,441,484},
/*5=atbash*/        {9,8,7,6,5,4,3,2,1,
                     90,80,80,70,60,60,50,50,40,30,20,20,10,10,
                     400,300,200,100}
                    };

 uint i,j,k=0;
 unsigned char bu;
 bool ok;

 j=0;
 ok=FALSE;
 for(k=0;k<8;k++) gemsum[k]=0;
 for(i=0;i<text.length();i++)
 {
  bu=text.at(i);
  if(bu>223 && bu<251)
  {
   j=bu-224;
   for(k=0;k<6;k++) gemsum[k+2]=gemsum[k+2]+tabgem[k][j];
 	  gemsum[1]++;
   ok=TRUE;
  }
  else
  {
   if(ok) gemsum[0]++;
   ok=FALSE;
  }
 }
}

















