/***************************************************************************
                          bintervall.h  -  description
                             -------------------
    begin                : Wed Dec 1 1999
    copyright            : (C) 1999 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BINTERVALL_H
#define BINTERVALL_H


/**
  *@author Heinz Schumann

 The class of 'BIntervall' search the occur of ELS to hebrew word in the
 biblebook and output the results in a list.
*/

#include <qobject.h>

class BHebIdx;
class BHebBuch;

class BIntervall : public QObject
{
 Q_OBJECT

 public:
	BIntervall();
  virtual ~BIntervall();

/**
 The method 'suchIntervall' search the occur of ELS to hebrew word in the
 biblebook and output the results in a list "ilst.zwi".
 Parameters the methode is:
 1. Name of biblebook
 2. Hebrew word
 3. Startposition data area
 4. Endposition data area
 5. Begining seqenz of ELS
 6. End seqenz of ELS
 7. ELS-Route (0=double-sided, 1=forward, 2=backward)
 8. Sort output (TRUE=sort to ELS, FALSE=sort to position)
*/
  bool suchIntervall(QString, QString, int, int, int, int, int, bool);

private:
 BHebBuch *heb;
 BHebIdx  *idx;
};

#endif


















