/***************************************************************************
                          bnachbar.h  -  description
                             -------------------
    begin                : Thu Jan 6 2000
    copyright            : (C) 2000 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BNACHBAR_H
#define BNACHBAR_H


/**
  *@author Heinz Schumann
  */

#include <qobject.h>

class BHebBuch;
class BHebIdx;

class BNachbar : public QObject
{
 Q_OBJECT

 public:
	BNachbar();
	~BNachbar();
  bool suchNachbar(QString, QString *, int, int);

 signals:
 void progressValue(int);
 void progressActuality(int);

 public slots:

 void slotStop();

 private:
  BHebBuch *heb;
  BHebIdx  *idx;

  void  abstand(int, int);
  float wurzel(int, int, int);

  int inter[5];
  int apos[5];
  int epos[5];
  int aber[5];
  int eber[5];
  int prozi[5];
  int   adom;
  int   edom;
  int   proz;
  int   seq;
  float abst;
  bool _stop;                           // Market stop
};

#endif










