/***************************************************************************
                          btextabbild.h  -  description
                             -------------------
    begin                : Sun Jan 23 2000
    copyright            : (C) 2000 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


#ifndef BTEXTABBILD_H
#define BTEXTABBILD_H

#include <qobject.h>
#include "bitana.h"

#define BLDBRT 80
#define ZLBRT  60
#define MAXBRT 85
#define ANZZL  34
#define LNGHWRT 35

/**
  *@author Heinz Schumann
*/

class BHebBuch;
class BHebIdx;
class BLexikon;

class BTextAbbild : public QObject
{
 Q_OBJECT
 public:
	BTextAbbild();
	~BTextAbbild();
  bool abbild(QString, QString, int, int, bool);

 public slots:

  void slotStop();

 private:
  BHebIdx   *_idx;
  BLexikon  *_lex;
  BHebBuch  *_cod;
  char      *_daten;

  bool  startSuche();
  bool  _check();
  void  _einsort();
  float _abstand();
  float _diff(int,int,int);
  int   _absPosition();
  bool _stop;
  char _text[MAXBRT];
  int  _lfdint;
  int  _lfdzl;
  int  _lfdch;
  int  _fak;
  int  _faki;
  int  _beglfdwrt;
  int  _endlfdwrt;
  int  _beglfdzl;
  int  _anzchar;
  int  _zlbrt;
  int  _inter;
  int  _begsuwrt;
  int  _endsuwrt;
  int  _anzzl;
  int  _anzbu;
  int  _lfdbu;
  int  _begpos;
  int  _endpos;
  int  _begfldpos;
  int  _endfldpos;
  int  _anzwrt;
  int  _anzgef;

  struct GEF
  {
   float abst;
   int  pos;
   int  seq;
   char ri;
   char la;
   char heb[LNGHWRT];
  };

  GEF gef;
  GEF *sor;

};

#endif




