/***************************************************************************
                          btxtbuch.cpp  -  description
                             -------------------
    begin                : Wed Dec 1 1999
    copyright            : (C) 1999 by Heinz Schumann
    email                : heinz@bitana.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

#include <kapp.h>
#include <qmessagebox.h>
#include <qdir.h>
#include <qfile.h>

#include "btxtbuch.h"
#include "bitana.h"

BTxtBuch::BTxtBuch()
{
 name=" ";
}

BTxtBuch::~BTxtBuch()
{
 f1.close();
}

bool BTxtBuch::lesText(QString buch, int kap, int vers)
{
 QString txk;
 QString txv;
 QString verz;
 extern BitanaApp *bitana;

 if(strcmp(name,buch))
 {
  name=buch;
  if(f1.isOpen()) f1.close();
  buch=buch.append(".txt");
  QDir d=QDir::root();
  if (d.cd(bitana->getBookLangDir()))
  {
   f1.setName( d.filePath(buch));
   if (!f1.open(IO_ReadOnly))
   {
    QMessageBox::warning(0,i18n("Error"),
                           i18n("Cannot find the file\n")+buch);
    return false;
   }
  }
  else
  {
   verz=bitana->getBookLangDir();
   QMessageBox::warning(0,i18n("Error"),
                          i18n("Cannot find the book directory")+verz);
   return false;
  }
  _k=_v=0;
 }
 if(kap<_k || (kap==_k && vers<=_v))
 {
  f1.at(0);                            // Pointer to begin of file
  _k=_v=0;
 }
 QTextStream dat(&f1);
 QString txt;

// Search the text
 do
 {
  if(dat.eof()) return false;
  txt = dat.readLine();
  txk=txt.mid(3,3);
  txv=txt.mid(7,2);
  _k=txk.toInt();
  _v=txv.toInt();
 } while(_k<kap || (_k==kap && _v<vers));

// Modify and move the text
 txt.remove(0,12);
 text=txt.copy();
 return true;
}



































